



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>java垃圾回收那点事（二）不同gc策略的heap分配</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">java垃圾回收那点事（二）不同gc策略的heap分配</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-24 18:43:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在前面的文章中曾提到了在java虚拟机启动的时候会对G1,CMS, SerialGC定义不同的heap的类，并且定义不同的policy。</p>
<p>CollectorPolicy</p>
<p>CollectorPolicy主要是用于根据虚拟机启动的参数分配heap的大小，和将heap堆分不同的区的大小（比如yong区和Old区），并且对不同的区定义不同的generation的规范。</p>
<p>GenerationSpec</p>
<p>主要是根据不同的类型使用不同的Generation的方式，这个类型是由CollectionPolicy在初始化GenerationSpec所指定的</p>
<p>例如MarkSweepPolicy ,在initialize_generations的方法中初始话GenerationSpec</p>
<pre class="prettyprint linenums">void MarkSweepPolicy::initialize_generations() {<br />
  initialize_perm_generation(PermGen::MarkSweepCompact);<br />
  _generations = new GenerationSpecPtr[number_of_generations()];<br />
  if (_generations == NULL)<br />
    vm_exit_during_initialization("Unable to allocate gen spec");

  if (UseParNewGC &amp;&amp; ParallelGCThreads &gt; 0) {<br />
    _generations[0] = new GenerationSpec(Generation::ParNew, _initial_gen0_size, _max_gen0_size);<br />
  } else {<br />
    _generations[0] = new GenerationSpec(Generation::DefNew, _initial_gen0_size, _max_gen0_size);<br />
  }<br />
  _generations[1] = new GenerationSpec(Generation::MarkSweepCompact, _initial_gen1_size, _max_gen1_size);

  if (_generations[0] == NULL || _generations[1] == NULL)<br />
    vm_exit_during_initialization("Unable to allocate gen spec");<br />
}</pre>
<p>下面表格描述的是不同的类型所对应的generation的方式</p>
<table>
<tbody>
<tr>
<td>类型</td>
<td>条件</td>
<td>generation的方式</td>
</tr>
<tr>
<td>Generation::DefNew</td>
<td>不使用UseParNewGC 或者使用UseParNewGC但设置ParallelGCThreads小于1（用于young区）</td>
<td>DefNewGeneration</td>
</tr>
<tr>
<td>Generation::ParNew</td>
<td>使用UseParNewGC并且ParallelGCThreads线程数大于1（用于young区）</td>
<td>ParNewGeneration</td>
</tr>
<tr>
<td>Generation::ASParNew</td>
<td>使用CMS,并且UseAdaptiveSizePolicy用于young区</td>
<td>ASParNewGeneration</td>
</tr>
<tr>
<td>Generation::MarkSweepCompact</td>
<td>使用UseSerialGC，用于old区</td>
<td>TenuredGeneration （）</td>
</tr>
<tr>
<td>Generation::ConcurrentMarkSweep</td>
<td>CMS 的old区</td>
<td>ConcurrentMarkSweepGeneration</td>
</tr>
<tr>
<td>Generation::ASConcurrentMarkSweep</td>
<td>使用CMS,并且UseAdaptiveSizePolicy，用于old区</td>
<td>ASConcurrentMarkSweepGeneration</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqllkx1q.html">android 获取屏幕宽度和高度</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mx5729.html">Codevs 1860 最大数 string大法好&comma;STL万岁。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2nv23q.html">Python中sorted&lpar;&rpar;方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gvwne9.html">dubbo 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew3kv9.html">IntelliJ IDEA 注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3x6p9.html">【链表】BZOJ 2288&colon; 【POJ Challenge】生日礼物</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m4k5xq.html">PHP搭建简单暴力的mvc</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m4pwkq.html">verilog中阻塞复制，非阻塞复制，顺序块，并行块之间的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjp3mx8.html">算法与数据结构&lpar;二&rpar; 栈与队列的线性和链式表示&lpar;Swift版&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj42r8.html">PhoenixFD插件流体模拟&mdash;&mdash;UI布局【Dynamics】详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jkr35q.html">Java源码阅读的真实体会&lpar;一种学习思路&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvze0l8.html">&lbrack;LTR&rsqb; RankLib&period;jar 包介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw44j79.html">Android之扫描文件或文件夹</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllz75xq.html">Zipper（poj2192）dfs&plus;剪枝</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4njweq.html">【python】关于python中模块导入的总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v56rzq.html">ELK之在windows安装filebeat收集日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pn2kw8.html">nyoj 吃土豆</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vdkn4q.html">mysql时间函数和时间操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p6ngz8.html">简例 - robot case格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppevyd9.html">C&num; 7&period;0特性与vs2017</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9ge12148.html">&lbrack;置顶&rsqb; 编程模仿boost&colon;&colon;function和boost&colon;&colon;bind</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1km0v09.html">一步一步重写 CodeIgniter 框架 &lpar;4&rpar; &mdash;&mdash; load&lowbar;class 管理多个对象实例的思路</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7zj38.html">html5游戏开发--&amp;quot&semi;动静&amp;quot&semi;结合用地图块拼成大地图 &amp;amp&semi; 初探lufyl</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgze0e8.html">手游接入Facebook的那些坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/950xrrz8.html">分享一个获取代理ip的python函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojkjoeq.html">编译mapnik（win7 环境下vs2008编译mapnik 0&period;7&period;1 成功）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgd5d78.html">myeclispe启动后报错 Subclipse talks to Subversion via a Java API that requires access to native libraries&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gemjk08.html">基于visual Studio2013解决C语言竞赛题之1066进制转化</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gempee8.html">&lbrack;置顶&rsqb; 用mootools实现checkbox全选功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yxpkr8.html">Cocos2d-x 学习（1）&mdash;&mdash; 通过Cocos Studio创建第一个Demo</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
